;   - *

.model tiny
.code

;baudrate	equ	300		;Baudrate
baudrate	equ	1200		;Baudrate
	;*            ^^^^^  ࠡ, 300  - 
	;                                    1200 - 
	;                                     -  ஡ :(

;freq1		equ	1500		;Border Frequency 1
freq1		equ	1000		;Border Frequency 1
;freq2		equ	1900		;Border Frequency 2
freq2		equ	2500		;Border Frequency 2
;tone		equ	1700		;Frequency detector RX
tone		equ	1850		;Frequency detector RX
	;*             ^^^^^^  - ।  室 䨫
	; 	 ᬥ , ᫨ 㦭, ⠪  freq1  freq2

;tries		equ	4		;Switch tries RX
tries		equ	1		;Switch tries RX
	;*            ^^^^  ⠭, । १  樨,
	;                  300  - 3..4
	;		   1200  - 1

each		equ	3		;Output on screen each ...
;each		equ	10		;Output on screen each ...
decrease	equ	300		;Decrease down picture each ...
;decrease	equ	10000		;Decrease down picture each ...
speed		equ	1193000 	;Timer speed
maxtable	equ	1000		;Max. table elements
maxbuffer	equ	300		;Max size of RX buffer
bittime 	equ	speed/baudrate  ;Time to 1 bit
;HAMint  	equ	0Ch		;Int number for HAMCOMM modem
HAMint  	equ	0Dh		;Int number for HAMCOMM modem
	;*            ^^^^^^^^^
	;            H  뢠

;HAMport 	equ	3F8h		;Port base for HAMCOMM modem
HAMport 	equ	3E8h		;Port base for HAMCOMM modem
	;*             ^^^^^^
	;             H 


; COM port         H         H  뢠
;  
; COM1                	3F8h			0Ch
; COM2			2F8h			0Bh
; COM3			3E8h			0Ch
; COM4			2E8h			0Bh


	org 100h

start:
	jmp main



;*********************** Variables *********************************************


wasDSR  	db	0
isDSR		db	0
wasout  	db	0

istimer 	dw	0
wastimer	dw	0
wastimer0	dw	0
wastimer1	dw	0
difference	dw	0
lastchange	dw	0

enablei 	db	1
colorofcenter	db	01010101b
video		db	0
hi		db	80 dup (0),0,0
decr		dw	decrease
bral		db	0

switch  	db	0
ifeach  	db	each
waspos  	dw	159
pred		dw	159

wasAX		dw	0
wasDS		dw	0

headptr 	dw	0
tailptr 	dw	0
table		dw	maxtable dup (0),0,0,0,0,0,0,0,0

bufptr  	dw	0
buffer  	db	maxbuffer dup (0),0,0,0,0
bits		db	0
printinfo	db	0
command 	db	0

SABM		db	'SABM$'
DISC		db	'DISC$'
UI		db	'UI$'
DM		db	'DM$'
UA		db	'UA$'
RR		db	'RR$'
RNR		db	'RNR$'
REJ		db	'REJ$'
FRMR		db	'FRMR$'
I		db	'I$'
UNKN		db	'?$'

info		db	13,10
		db	'ਥ  (300 )   1.4      UU9JDR.',13,10
		db	'ॡ XT  HAMCOMM  (1700 )  COM2.',13,10
		db	' ''pacswl.com >.''    䠩.',13,10
		db	' - ன,  㣠  - 室.',13,10
		db	'$'
started 	db	13,10,'砫 ਥ: $'
stopped 	db	13,10,'  ਥ: $'
at		db	'  $'
tape		db	''
		db	' 1500                1600               1700              1800             1900             '


crc16tab   dw	  00000h,01189h,02312h,0329Bh,04624h,057ADh,06536h,074BFh
	dw	  08C48h,09DC1h,0AF5Ah,0BED3h,0CA6Ch,0DBE5h,0E97Eh,0F8F7h
	dw	  01081h,00108h,03393h,0221Ah,056A5h,0472Ch,075B7h,0643Eh
	dw	  09CC9h,08D40h,0BFDBh,0AE52h,0DAEDh,0CB64h,0F9FFh,0E876h
	dw	  02102h,0308Bh,00210h,01399h,06726h,076AFh,04434h,055BDh
	dw	  0AD4Ah,0BCC3h,08E58h,09FD1h,0EB6Eh,0FAE7h,0C87Ch,0D9F5h
	dw	  03183h,0200Ah,01291h,00318h,077A7h,0662Eh,054B5h,0453Ch
	dw	  0BDCBh,0AC42h,09ED9h,08F50h,0FBEFh,0EA66h,0D8FDh,0C974h
	dw	  04204h,0538Dh,06116h,0709Fh,00420h,015A9h,02732h,036BBh
	dw	  0CE4Ch,0DFC5h,0ED5Eh,0FCD7h,08868h,099E1h,0AB7Ah,0BAF3h
	dw	  05285h,0430Ch,07197h,0601Eh,014A1h,00528h,037B3h,0263Ah
	dw	  0DECDh,0CF44h,0FDDFh,0EC56h,098E9h,08960h,0BBFBh,0AA72h
	dw	  06306h,0728Fh,04014h,0519Dh,02522h,034ABh,00630h,017B9h
	dw	  0EF4Eh,0FEC7h,0CC5Ch,0DDD5h,0A96Ah,0B8E3h,08A78h,09BF1h
	dw	  07387h,0620Eh,05095h,0411Ch,035A3h,0242Ah,016B1h,00738h
	dw	  0FFCFh,0EE46h,0DCDDh,0CD54h,0B9EBh,0A862h,09AF9h,08B70h
	dw	  08408h,09581h,0A71Ah,0B693h,0C22Ch,0D3A5h,0E13Eh,0F0B7h
	dw	  00840h,019C9h,02B52h,03ADBh,04E64h,05FEDh,06D76h,07CFFh
	dw	  09489h,08500h,0B79Bh,0A612h,0D2ADh,0C324h,0F1BFh,0E036h
	dw	  018C1h,00948h,03BD3h,02A5Ah,05EE5h,04F6Ch,07DF7h,06C7Eh
	dw	  0A50Ah,0B483h,08618h,09791h,0E32Eh,0F2A7h,0C03Ch,0D1B5h
	dw	  02942h,038CBh,00A50h,01BD9h,06F66h,07EEFh,04C74h,05DFDh
	dw	  0B58Bh,0A402h,09699h,08710h,0F3AFh,0E226h,0D0BDh,0C134h
	dw	  039C3h,0284Ah,01AD1h,00B58h,07FE7h,06E6Eh,05CF5h,04D7Ch
	dw	  0C60Ch,0D785h,0E51Eh,0F497h,08028h,091A1h,0A33Ah,0B2B3h
	dw	  04A44h,05BCDh,06956h,078DFh,00C60h,01DE9h,02F72h,03EFBh
	dw	  0D68Dh,0C704h,0F59Fh,0E416h,090A9h,08120h,0B3BBh,0A232h
	dw	  05AC5h,04B4Ch,079D7h,0685Eh,01CE1h,00D68h,03FF3h,02E7Ah
	dw	  0E70Eh,0F687h,0C41Ch,0D595h,0A12Ah,0B0A3h,08238h,093B1h
	dw	  06B46h,07ACFh,04854h,059DDh,02D62h,03CEBh,00E70h,01FF9h
	dw	  0F78Fh,0E606h,0D49Dh,0C514h,0B1ABh,0A022h,092B9h,08330h
	dw	  07BC7h,06A4Eh,058D5h,0495Ch,03DE3h,02C6Ah,01EF1h,00F78h

;*********************** Main program *****************************************

main:

		mov	al,00000111b
		call	color		;Set screen visible

		mov	ah,3
		mov	bh,0
		int	10h		;Read cursor pos

		mov	si,dx		;Store..

		mov	al,32
		mov	ah,2h
		mov	bx,0
		mov	dl,al
		int	21h		;Print a char via DOS

		mov	ah,3
		mov	bh,0
		int	10h		;Read once again

		mov	al,1
		cmp	si,dx		;There was any change?
		je	intofile
		mov	al,0
intofile:
		mov	video,al	;Store File/File+Screen flag

		mov	si,80h
		cmp	byte ptr [si],1
		jbe	nogiveinfo

		lea	dx,info
		call	printstring
;		mov	ah,9
;		int	21h

nogiveinfo:
		call install
		mov	ax,cs
		mov	es,ax
		mov	ds,ax

clearbuffer:
		mov	bufptr,0
		mov	bits,0

nextbits:
		call	read
	;	 cmp	ax,bittime/3
	;	 jbe	nextbits;	;0<x<0.5  It's error

		mov	cx,1
		mov	bl,0
		cmp	ax,bittime+bittime/2
		jbe	wrbuffer	;if 0.5<x<1.5 then 1 bit=0

		inc	cx
		mov	bl,01b
		cmp	ax,bittime*2+bittime/2
		jbe	wrbuffer	;if 1.5<x<2.5 then 2 bits=01

		inc	cx
		mov	bl,011b
		cmp	ax,bittime*3+bittime/2
		jbe	wrbuffer	;if 2.5<x<3.5 then 3 bits=011

		inc	cx
		mov	bl,0111b
		cmp	ax,bittime*4+bittime/2
		jbe	wrbuffer	;if 3.5<x<4.5 then 4 bits=0111

		inc	cx
		mov	bl,01111b
		cmp	ax,bittime*5+bittime/2
		jbe	wrbuffer	;if 4.5<x<5.5 then 5 bits=01111

		mov	bl,11111b	;Bitstuffing
		cmp	ax,bittime*6+bittime/2
		jbe	wrbuffer	;if 5.5<x<6.5 then 5 bits=11111

		; cmp	ax,bittime*7+bittime/2
		; ja	waitforflag ;error		;if x>7.5 then  error!

					;It's a flag!
		call	printbuffer
		jmp	clearbuffer

wrbuffer:
		mov	bh,bl
		and	bh,1
		mov	si,bufptr
		and	byte ptr [si+offset buffer],11111110b
		or	[si+offset buffer],bh
		ror	bl,1
		ror	byte ptr [si+offset buffer],1
		inc	bits
		cmp	bits,8
		jnz	nonextbyte
		inc	si
		mov	bufptr,si
		cmp	si,maxbuffer
		jae	error
		mov	bits,0
nonextbyte:

		loop	wrbuffer
		jmp	nextbits

error:
		call	printbuffer
		jmp	clearbuffer

;*********************** Subprograms *************************************

;*********************** Interrupt handler ************************************

interrupt:
		cli
		push ax bx cx dx ds es si

		mov	ax,cs
		mov	ds,ax

		mov	al,0
		out	43h,al
		in	al,40h
		mov	ah,al
		in	al,40h  		;reading from timer
		xchg	ah,al
		mov	istimer,ax

		mov	bral,0  		;Ne bral indikator

		mov	al,3
		mov	dx,HAMport+3
		out	dx,al			;line ctrl

		mov	dx,HAMport+6
		in	al,dx			;modem status
		and	al,00100000b
		mov	isDSR,al

		or	al,al
		jz	thereis0
thereis1:
		mov	ax,wastimer1
		mov	wastimer,ax
		jmp	separated
thereis0:
		mov	ax,wastimer0
		mov	wastimer,ax
separated:

		mov	al,8
		mov	dx,HAMport+1
		out	dx,al			;int enable

		mov	ax,wastimer
		sub	ax,istimer

processtimer:

		mov	bx,istimer


		mov	cl,isDSR
		or	cl,cl
		jz	thereis00
thereis01:
		mov	wastimer1,bx
		jmp	comparetone
thereis00:
		mov	wastimer0,bx

comparetone:
		mov	difference,ax
		cmp	ax,speed/tone
		jbe	decswitch

incswitch:


		cmp	switch,tries
		jae	switchmade			;Top of switch?
		inc	switch
		jmp	switchmade
decswitch:


		cmp	switch,0
		jbe	switchmade			;Bottom of switch?
		dec	switch

switchmade:


;Switch=0	 <------> 1
;Switch=tries	 <------> 0

;				      Switch
;		   1  <     |0| |1| |2| ... |tries|	>  0

		cmp	wasout,1      ;Out was 1 ?
		jz	outwas1

outwas0:
		cmp	switch,0
		mov	al,1		     ;If was out 0 and switch=0
		je	writetotable	     ;Then out 1
		jmp	nowrite 	     ;If was out 0 and 0<switch<=tries
					     ;Then
					     ;without change

outwas1:
		cmp	switch,tries
		mov	al,0		     ;If was out 1 and switch=tries
		je	writetotable	     ;Then out 0
					     ;If was out 1 and 0<=switch<tries
		jmp nowrite		     ;Then
					     ;without change

writetotable:
		mov	wasout,al
		call	write


nowrite:

indication:
		cmp	enablei,0
		je	cycle

		mov	ax,0B800h
		mov	es,ax
		mov	ax,difference


		sub	ax,speed/freq2
		sar	ax,1
		and	ax,1111111111111110b

		cmp	ax,80
		ja	cycle

		cmp	ax,0
		jb	cycle

		mov	bx,159
		sub	bx,ax

		cmp	bx,pred
		mov	pred,bx
		jne	cycle

		dec	ifeach
		cmp	ifeach,0
		jne	cycle
		mov	ifeach,each


		push	bx
		mov	bx,waspos
		mov	byte ptr es:[bx],00001111b
		pop	bx
		mov	byte ptr es:[bx],01110000b
		mov	waspos,bx
		mov	bx,159-(((speed/tone-speed/freq2)/2) and 1111111111111110b)
		mov	al,colorofcenter
		mov	byte ptr es:[bx],al


cycle:
		mov	dx,HAMport
		in	al,dx			; port baseport, RS232-2 recv buffr
		mov	dx,HAMport+5
		in	al,dx			; port baseport+5, RS232-2 line stat
		mov	dx,HAMport+6
		in	al,dx			; port baseport+6, RS232-2 modem stat
		mov	dx,HAMport+2
		in	al,dx			; port baseport+2 INT ID
		cmp	al,1
		jne	cycle			; Jump if not equal

		mov	al,20h  		; ' '
		out	20h,al  		; port 20h, 8259-1 int command
						;  al = 20h, end of interrupt


		pop si es ds dx cx bx ax

		sti
		iret



;******** Installation *******************
install 	proc	near

		cli
		xor	ax,ax
		mov	es,ax
		mov	ax,es:HAMint*4
		mov	wasAX,ax
		mov	ax,es:HAMint*4+2
		mov	wasDS,ax
		mov	ax,offset interrupt
		mov	es:HAMint*4,ax
		mov	es:HAMint*4+2,ds


		mov	al,3
		mov	dx,HAMport+3
		out	dx,al			; port baseport+3, RS232-2 line cntrl

		mov	al,8
		mov	dx,HAMport+1
		out	dx,al			; port baseport+1, RS232-2 int enable

		mov	al,0
		out	21h,al  		; port 21h, 8259-1 int comands


		mov	al,0Dh
		mov	dx,HAMport+4
		out	dx,al


cycle1:
		mov	dx,HAMport+5
		in	al,dx			; port baseport+5, RS232-2 line stat
		mov	dx,HAMport+6
		in	al,dx			; port baseport+6, RS232-2 modem stat
		mov	dx,HAMport
		in	al,dx			; port baseport, RS232-2 recv buffr
		mov	dx,HAMport+2
		in	al,dx			; port baseport+2  int id

		cmp	al,1
		jne	cycle1  		; Jump if not equal

		mov	al,34h
		out	43h,al

		mov	al,0FFh
		out	40h,al
		out	40h,al  		;timer prog

		sti




		push	cs
		pop	es


		lea	dx,started
		call	printstring
		call	printdate
		lea	dx,at
		call	printstring
		call	printtime

		mov	al,'.'
		call	printchar
		mov	al,13
		call	printchar
		mov	al,10
		call	printchar

		retn
install 	endp

;******** Deinstallation *******************
deinstall		proc	near

		lea	dx,stopped
		call	printstring
		call	printdate
		lea	dx,at
		call	printstring
		call	printtime
		mov	al,'.'
		call	printchar
		mov	al,13
		call	printchar
		mov	al,10
		call	printchar


		cli				; Disable interrupts
		xor	ax,ax
		mov	es,ax
		mov	ax,wasAX		;Normalize int vector
		mov	es:HAMint*4,ax
		mov	ax,wasDS
		mov	es:HAMint*4+2,ax

		mov	al,es:[41Ah]		;Clear kbd buffer
		mov	es:[41Ch],al
		sti

		int	20h

deinstall	endp

;**************** Write to table ****************
write		proc	near

		push	cs
		push	cs
		pop	ds
		pop	es

		mov	si,headptr
		mov	ax,lastchange
		sub	ax,istimer
		mov	[si+offset table],ax
		mov	ax,istimer
		mov	lastchange,ax
		inc	si
		inc	si
		cmp	si,maxtable*2
		jnz	cyclehead
		mov	si,0
cyclehead:
		cmp	si,tailptr
		mov	al,0
		je	notwrite		;Overflow
		mov	al,01010101b
		mov	headptr,si
notwrite:
		mov	colorofcenter,al
		retn
write		endp

;********** Read from table ***********
read		proc	near		;Out: AX=delay

		mov	si,tailptr
cycletail:
		mov	ah,1
		int	16h
		jz	nokey
		cmp	al,' '
		jne	akey
		call	tune
		jmp	nokey
akey:
		jmp	deinstall		;Waiting for anything
nokey:
		cmp	si,headptr
		je	cycletail
		mov	bx,[si+offset table]
		inc	si
		inc	si
		cmp	si,maxtable*2
		jnz	freeread
		mov	si,0
freeread:
		mov	tailptr,si
		mov	ax,bx
		retn
read		endp

;*************** Printing buffer on screen *******
printbuffer	proc	near
		mov	command,0

		cmp	bits,1
		je	goodbits	;Integer number of received bits?
		jmp	noatall
goodbits:

		cmp	bufptr,16		;Too small packet?
		ja	cmpCRC
		jmp	noatall
cmpCRC:
		mov	si,bufptr
		sub	si,2
		mov	bx,word ptr [si+offset buffer]

		mov	cx,bufptr
		sub	cx,2
		call	crc
		xor	ax,0FFFFh

		cmp	ax,bx			;CRC ok?
		je	outtime
		jmp	noatall

outtime:
		call	printtime		;Printing time
		mov	al,' '
		call	printchar

		mov	si,7			;Print sender
		call	printcall
		mov	al,[si+offset buffer+6]

		mov	command,al
		and	command,10000000b	;Command?

		and	al,1			;Last call?
		jnz	lastcall

		mov	al,'/'
		call	printchar


printrptr:
		add	si,7			;Next repeater
		cmp	si,71
		jbe	goodquan

		jmp	noprintbuffer
goodquan:
		call	printcall
		mov	al,[si+offset buffer+6]
		push	ax
		test	ax,10000000b
		jz	notpassed
		mov	al,'*'
		call	printchar
notpassed:
		pop	ax
		and	al,1			;Last call?
		jnz	lastcall
		mov	al,'/'
		call	printchar
		jmp	printrptr
lastcall:
		push	si
		mov	al,'>'
		call	printchar
		mov	si,0
		call	printcall
		pop	si
		add	si,7			;Addr of Control field
		mov	al,'>'
		call	printchar

		call	printCtrl

		cmp	printinfo,0
		je	noatall

		mov	dx,bufptr
		sub	dx,4
		inc	si
nextinfopos:
		inc	si
		mov	al,[si+offset buffer]

		cmp	al,7
		jne	notCtrlG
		mov	al,'^'
		call	printchar
		mov	al,'G'
		call	printchar
		jmp	badletter
notCtrlG:

		cmp	al,26
		jne	notCtrlZ
		mov	al,'^'
		call	printchar
		mov	al,'Z'
		call	printchar
		jmp	badletter
notCtrlZ:

		cmp	al,13
		jne	notCR
		call	printchar
		mov	al,10
		call	printchar
		jmp	badletter
notCR:
		cmp	al,20h
		jb	badletter
		call	printchar
badletter:
		cmp	si,dx
		jbe	nextinfopos
noprintbuffer:
		mov	al,13
		call	printchar
		mov	al,10
		call	printchar
noatall:




		retn
printbuffer	endp

;*********** Out chr to screen in HEX *************
outHEX  	proc	near		;In: AL=number

		push	ax
		mov	ah,al

		sar	al,1
		sar	al,1
		sar	al,1
		sar	al,1

		and	al,00001111b
		add	al,'0'
		cmp	al,'9'
		jbe	big9h
		add	al,'A'-'9'-1
big9h:
		call	printchar

		mov	al,ah
		and	al,00001111b
		add	al,'0'
		cmp	al,'9'
		jbe	big9l
		add	al,'A'-'9'-1
big9l:
		call	printchar

		pop	ax
		retn
outHEX  	endp
;*************** Print Call Sign on the screen **********
						;SI=call start in buffer
printcall	proc	near

		push	si
		push	cx
		push	ax
		push	si

		mov	cx,6			;Print 6 chars
nextcallchar:
		mov	al,[si+offset buffer]
		sar	al,1
		and	al,01111111b
		cmp	al,' '
		jbe	printSSID
		call	printchar
		inc	si
		loop	nextcallchar
printSSID:					;Print SSID
		pop	si
		mov	al,[si+offset buffer+6]
	; call printnum
		sar	al,1
		and	al,1111b
		mov	ah,al
		cmp	al,0
		jz	SSIDis0
		mov	al,'-'
		call	printchar
		mov	al,ah
		call	printnum
SSIDis0:
		pop	ax
		pop	cx
		pop	si

		retn
printcall	endp
;************* Print char on the screen ***********
						; AL=char
printchar	proc	near

		push	ax bx cx dx

		push	ax


		mov	ah,0Eh
		mov	bx,0
		mov	cx,0
		int	10h

		pop	ax
		cmp	video,0
		je	notviaDOS

		mov	ah,2h
		mov	bx,0
		mov	dl,al
		int	21h
notviaDOS:
		pop	dx cx bx ax

		retn
printchar	endp
;**************** Print string of chars ************************
printstring	proc	near			;DS:DX=start, term='$'

		push	dx si ax

nextpos:	mov	si,dx
		mov	al,[si]
		cmp	al,'$'
		jz	endstring
		cmp	al,13
		jne	nopsCR
		call	printchar
		mov	al,10
		call	printchar
nopsCR:
		cmp	al,' '
		jb	noprinted
		call	printchar
noprinted:
		inc	dx
		jmp	nextpos
endstring:
		pop	ax si dx

		retn
printstring	endp
;**************** Print number on the screen in DEC ************
						;AL=number<100
printnum	proc	near

		push	ax
		push	bx
		push	cx

		mov	bl,al
		mov	wasb,0
		mov	ah,0
		mov	cl,100
		div	cl
		cmp	al,0
		jz	below100
		mov	wasb,255
		add	al,'0'
		call	printchar
below100:
		mov	al,ah
		mov	ah,0
		mov	cl,10
		div	cl
		cmp	al,wasb
		jz	below10
		add	al,'0'
		call	printchar
below10:
		mov	al,ah
		cmp	al,0
		jz	noprintthisdigit
		add	al,'0'
		call	printchar
noprintthisdigit:
		pop	cx
		pop	bx
		pop	ax

		retn

wasb		db	0
printnum	endp
;***************** Print two digits *************
print2  	proc	near			;AL=number <100
		push	ax cx

		mov	ah,0
		mov	cl,10
		div	cl
		add	al,'0'
		call	printchar
		xchg	ah,al
		add	al,'0'
		call	printchar

		pop	cx ax
		retn
print2  	endp

;***************** Print number BCD *************
						;AL=number BCD <100
printBCD	proc	near

		push	ax cx

		mov	ah,al
		mov	cl,4
		sar	al,cl
		and	al,1111b
		add	al,'0'
		call	printchar
		mov	al,ah
		and	al,1111b
		add	al,'0'
		call	printchar

		pop	cx ax

		retn
printBCD	endp
;*************** Print time *******************
printtime	proc	near

		push	ax cx dx

		mov	ah,2Ch
		int	21h
		mov	al,ch
		call	print2
		mov	al,':'
		call	printchar
		mov	al,cl
		call	print2
		pop	dx cx ax

		retn
printtime	endp

;*************** Print date *******************
printdate	proc	near

		push	ax cx dx

		mov	ah,2Ah
		int	21h
		mov	al,dl
		call	print2
		mov	al,'.'
		call	printchar
		mov	al,dh
		call	print2
		mov	al,'.'
		call	printchar
		mov	al,cl
		sub	al,108
		call	printnum

		pop	dx cx ax

		retn
printdate	endp

;*************** Print Control field ***********
						;SI=pos of Ctrl field
printCtrl	proc	near

		push	si

		mov	printinfo,0
		mov	al,[si+offset buffer]
		mov	ah,al
;call	printnum

;mov	al,' '
;call	printchar
;mov	al,ah
		test	al,1
		jnz	notinfo
		jmp	thatisI 	;It is Info Packets!
notinfo:
		test	al,10b  	;Not Info...
		jnz	thatisU 	;It is Unnumbered!
					;It is Supervisor!

		and	al,1100b

		lea	dx,RR
		cmp	al,0000b	;RR?
		jz	print1number

		lea	dx,RNR
		cmp	al,0100b	;RNR?
		jz	print1number

		lea	dx,REJ
		cmp	al,1000b	;REJ?
		jz	print1number

		lea	dx,UNKN
print1number:
		call	printstring
		mov	al,ah
		mov	cl,5
		sar	al,cl
		and	al,111b
		add	al,'0'
		call	printchar
		mov	al,','
		call	printchar

		mov	al,'P'
		cmp	command,0	;Command?
		je	activeS
		mov	al,'F'
activeS:
		test	ah,10000b	;P/F?
		jnz	PFs
		mov	al,'R'
PFs:
		call	printchar
		jmp	endctrl



thatisU:
		and	al,11101100b

		lea	dx,SABM
		cmp	al,00101100b		;SABM?
		jz	printU

		lea	dx,DISC
		cmp	al,01000000b		;DISC?
		jz	printU

		lea	dx,UA
		cmp	al,01100000b		;UA?
		jz	printU

		lea	dx,DM
		cmp	al,00001100b		;DM?
		jz	printU

		lea	dx,FRMR
		cmp	al,10000100b		;FRMR?
		jz	printU

		lea	dx,UI
		cmp	al,00000000b		;UI?
		jz	printU

		lea	dx,UNKN
printU:
		call	printstring

		mov	al,','
		call	printchar

		mov	al,'P'
		cmp	command,0	;Command?
		je	activeU
		mov	al,'F'
activeU:
		test	ah,10000b	;P/F?
		jnz	PFu
		mov	al,'C'
PFu:
		call	printchar

		test	ah,11101100b
		jnz	notUI

		mov	al,','
		call	printchar

		mov	al,[si+offset buffer+1] 	;Print PID
		call	outHEX

		cmp	al,0F0h
		jne	badprotocoleU

		mov	printinfo,1
		mov	al,':'
		call	printchar

badprotocoleU:

notUI:

		jmp	endctrl



thatisI:
		lea	dx,I
		call	printstring

		sar	al,1
		and	al,111b
		add	al,'0'
		call	printchar

		mov	al,ah
		mov	cl,5
		sar	al,cl
		and	al,111b
		add	al,'0'
		call	printchar

		mov	al,','
		call	printchar

		mov	al,'P'
		cmp	command,0	;Command?
		je	activeI
		mov	al,'F'
activeI:
		test	ah,10000b	;P/F?
		jnz	PFi
		mov	al,'C'
PFi:
		call	printchar

		mov	al,','
		call	printchar

		mov	al,[si+offset buffer+1] 	;Print PID
		call	outHEX

		cmp	al,0F0h
		jne	badprotocoleI

		mov	printinfo,1
		mov	al,':'
		call	printchar

badprotocoleI:


endCtrl:
		mov	al,13
		call	printchar
		mov	al,10
		call	printchar

		pop	si
		retn
printCtrl	endp


;*************** CRC count ********************

crc		proc near			;In: CX=len
		push	bx 			;Out:AX=CRC
		push	cx
		push	si
	
		mov	si,0
		mov	ax,0FFFFh
		jcxz	CRC_16_2
CRC_16_1:
		mov	bl,byte ptr[si+offset buffer]
		inc	si
		xor	bl,al
		xor	bh,bh
		shl	bx,1
		mov	al,ah
		xor	ah,ah
		xor	ax,word ptr [crc16tab+bx]
		loop	CRC_16_1
CRC_16_2:
		pop	si
		pop	cx
		pop	bx
		retn

crc		endp

;***************** Color screen ********************
color		proc	near		;In: AL=color

		push	es di cx

		mov	di,0B800h
		push	di
		pop	es

		mov	di,1
		mov	cx,80*25
setcol:
		mov	es:[di],al
		inc	di
		inc	di

		loop	setcol
		pop	cx di es

		retn
color		endp

;******************* Tune indicator ********
tune		proc	near

		push	es si cx bx

		mov	enablei,0	;Disable indication


		mov	al,0
		call	color		;Screen blank

		cli				; Disable interrupts
		xor	ax,ax
		mov	es,ax
		mov	al,es:[41Ah]		;Clear kbd buffer
		mov	es:[41Ch],al
		sti

		call	xchgtape

		mov	cx,80
		lea	si,hi
nullhigh:
		mov	byte ptr[si],0  	;Height of all =0
		inc	si
		loop	nullhigh
tunec:

		cmp	bral,0  		;Ja uzhe bral?
		jne	noim

		mov	bral,1  		;Sejchas wozmu!

		mov	ax,0B800h
		mov	es,ax

		mov	bx,difference

		sub	bx,speed/freq2
		sar	bx,1
		and	bx,0111111111111111b

		cmp	bx,79
		ja	noim

		cmp	bx,0
		jb	noim

		mov	si,79
		sub	si,bx

		mov	al,byte ptr[si+offset hi]
		cmp	al,22
		jne	normalhigh
		jmp	decring
normalhigh:

		inc	al
		mov	byte ptr[si+offset hi],al

		shl	si,1
		and	si,1111111111111110b

		mov	ah,160
		mul	ah
		mov	bx,160*22+1
		sub	bx,ax

		mov	byte ptr es:[si+bx],01110111b

		mov	decr,decrease

		jmp	nodecr
noim:

toohigh:
		dec	decr
		cmp	decr,0  	;I must decrease?
		jne	nodecr
		mov	decr,decrease
decring:

		mov	si,80
loopdec:
		dec	si
		push	si

		mov	al,byte ptr[si+offset hi]
		cmp	al,0
		je	toolow
		dec	al
		mov	byte ptr[si+offset hi],al
		inc	al

		shl	si,1
		and	si,1111111111111110b
		mov	ah,160
		mul	ah
		mov	bx,160*22+1
		sub	bx,ax

		mov	byte ptr es:[si+bx],0


toolow:
		pop	si

		cmp	si,0
		jnz	loopdec

nodecr:

		mov	ah,1
		int	16h
		jnz	letsquit
		jmp	tunec
letsquit:
		push	ax

		cli				; Disable interrupts
		xor	ax,ax
		mov	es,ax
		mov	al,es:[41Ah]		;Clear kbd buffer
		mov	es:[41Ch],al
		sti

		call	xchgtape

		mov	al,00000111b
		call	color		;Set visible color

		mov	enablei,1	;Enable indication

		pop	ax
		cmp	al,' '
		je	wasspace
		jmp	deinstall		;Deinstallation

wasspace:
		pop	bx cx si es
		retn
tune		endp

;*********** Exchange tape ************************
xchgtape	proc	near

		mov	ax,0B800h
		mov	es,ax
		mov	cx,80*2
		lea	si,tape
		mov	di,80*2*22
xchgt:
		mov	al,byte ptr cs:[si]
		xchg	al,byte ptr es:[di]
		xchg	al,byte ptr cs:[si]
		inc	si
		inc	di
		mov	byte ptr es:[di],00000111b
		inc	di
		loop	xchgt

		retn
xchgtape	endp

end		start
                                                                                                                                                                                                     
